#ifndef _DUMPER_H
#define _DUMPER_H

typedef void (*progress_func) (U8 start, U32 current_sector, U32 total_sectors, void *progress_data);

typedef struct dumper_tag
{
	DISK_TYPE *dsk;
	char *outfile_iso;
	U32 start_sector_iso;
	FILE *fp_iso;
	U32 start_sector;
	U8 flushing;

	progress_func progress;
	void *progress_data;
} DUMPER_TYPE;

extern DUMPER_TYPE *dumper_new (DISK_TYPE *d);
extern U8 dumper_set_iso_output_file (DUMPER_TYPE *dmp, char *outfile_iso);
extern void dumper_set_progress_callback (DUMPER_TYPE *dmp, progress_func progress, void *progress_data);
extern S32 dumper_dump (DUMPER_TYPE *dmp);
extern U8 dumper_prepare (DUMPER_TYPE *dmp);
void *dumper_destroy (DUMPER_TYPE *dmp);

#endif
